namespace Mail.Providers
{
	using System;

	/// <summary>
    ///      .	
	/// </summary>
	public abstract class Provider : IDisposable
	{
        /// <summary>
        ///  .
        /// </summary>
		protected string _server;
        /// <summary>
        ///  .
        /// </summary>
		protected int _port;
		/// <summary>
		///      .
		/// </summary>
		string _tempdir;

		/// <summary>
		///   .
		/// </summary>
		/// <param name="login"> .</param>
		/// <param name="password">.</param>
		public abstract void LogIn(string login, string password);

		/// <summary>
		///  .
		/// </summary>
		public abstract void Quit();

		/// <summary>
		///  .
		/// </summary>
		/// <param name="index"> .</param>
		public abstract void DeleteMessage(uint index);

		/// <summary>
		///  .
		/// </summary>
        /// <param name="index"> .</param>
		public abstract Message GetMessage(uint index);


		/// <summary>
		///    .
		/// </summary>
		public string TempDirectory
		{
			get
			{
				return _tempdir;
			}
			set
			{
				_tempdir = value;
			}
		}

		/// <summary>
		///  .
		/// </summary>
		abstract public void Dispose();
	}
}